# -*- coding: utf-8 -*-
"""Random_ForestRegressor.ipynb

Automatically generated by Colab.

Original file is located at
    https://colab.research.google.com/drive/1XVFAjBkFUJcHLr5XUiU24aKkE7ySnJ_9

### Загружаем библиотеки
"""

# Commented out IPython magic to ensure Python compatibility.
import pandas as pd
import matplotlib.pyplot as plt
import numpy as np
import statsmodels.api as sm
import plotly
import seaborn
import sklearn
import scipy
# %matplotlib inline

from sklearn.model_selection import train_test_split
from sklearn.metrics import accuracy_score, mean_absolute_percentage_error
from sklearn.ensemble import RandomForestRegressor
from sklearn.metrics import accuracy_score
from scipy.stats import pearsonr
from sklearn.metrics import mean_absolute_error
from sklearn.metrics import mean_squared_error
from sklearn.metrics import r2_score
from sklearn.preprocessing import StandardScaler
from sklearn.preprocessing import LabelEncoder
from sklearn.metrics import accuracy_score, mean_absolute_percentage_error
from sklearn.svm import SVC
from sklearn.linear_model import LogisticRegression
from sklearn.tree import DecisionTreeClassifier, DecisionTreeRegressor
from sklearn.ensemble import RandomForestClassifier, RandomForestRegressor
from sklearn.ensemble import BaggingClassifier, VotingClassifier, ExtraTreesClassifier
from joblib import Parallel, delayed
from mlxtend.plotting import plot_decision_regions

"""###Отобразим наш заранее подготовленный датасет"""

df = pd.read_excel("Random Forest Regression.xlsx")
df.head()

"""### Нормализируем наши данные. Это облегчает сравнение, анализ и обработку данных, особенно при использовании алгоритмов машинного обучения"""

# from sklearn import preprocessing
# x_array=np.array(df)
# normalized_arr=preprocessing.normalize(x_array)
# print(normalized_arr)

# scaler = StandardScaler()
# df_scaler = scaler.fit_transform(df)
# df_new = pd.DataFrame(normalized_arr)
# df_new.columns = df.columns

df_new = df
df_new

"""###Удалим не нужные столбцы данных"""

df_new.drop('Продажи, упаковки', axis= 1 , inplace= True )
df_new.drop('неделя', axis= 1 , inplace= True )

df_new

"""### Построим корреляционную матрицу"""

print(df_new.corr(method='pearson'))
corr = df_new.corr()
corr.style.background_gradient(cmap='RdYlGn')

"""### Удалим выбросы с помощью 3 сигм"""

import scipy.stats as stats
import numpy as np
#find absolute value of z-score for each observation
z = np.abs(stats.zscore(df_new))

#only keep rows in dataframe with all z-scores less than absolute value of 3
df_new = df_new[(z<3).all(axis=1)]

#find how many rows are left in the dataframe
df_new.shape

"""### Разделим данные для обучения и проверки модели"""

x = df_new.iloc[:, :-1]
y = pd.DataFrame(df_new.iloc[:, -1])
x_train, x_test, y_train, y_test = train_test_split(x, y, test_size=0.30, random_state=0, shuffle=False)
x

"""### Создадим и обучим модель случайного леса, получим прогнозные значения и MAPE, RSQ"""

sk_random_forest_regressor = RandomForestRegressor(random_state=0, n_estimators =100, max_depth=20)
sk_random_forest_regressor.fit(x_train, y_train)
sk_rf_reg_pred_res = sk_random_forest_regressor.predict(x_test)
mape = mean_absolute_percentage_error(sk_rf_reg_pred_res, y_test)
print(f'mape: {mape}')
print(sk_rf_reg_pred_res)

d =np.array(y_test)

r2_score = r2_score(sk_rf_reg_pred_res, d)
print(f'RSQ: {r2_score}')

"""### Создание наглядного графика результатов"""

a = pd.DataFrame(sk_rf_reg_pred_res, columns= ['Предсказание'])
y_test.reset_index(drop= True, inplace= True)
result = y_test.join(a)
df2 = pd.read_excel("Date.xlsx")
df3 = df2.join(result)

df3

#plot both time series
plt.figure(figsize=(10, 4))
plt.plot (df3.Date , df3["Продажи, рубли"] , label='Продажи, рубли', linewidth= 3 )
plt.plot (df3.Date , df3["Предсказание"] , color='red', label='Предсказание', linewidth= 1 )

#add title and axis labels
# plt.title('Sales by Date')
# plt.xlabel('Date')
# plt.ylabel('Sales')

#add legend
plt.legend()

#display plot
plt.show()

"""### Выделим наиболее значимые факторы влияющие на прогноз модели"""

importances = sk_random_forest_regressor.feature_importances_
feature_importances = pd.Series(importances, index=x_train.columns)
feature_importances.sort_values(ascending=True).plot(kind='barh')